-- SpaceObjects are objects that use physics and 2D graphics
--article about classes in lua: http://www.inspired-lua.org/2011/05/5-object-classes/

require 'class'

SpaceObject = class(function(spaceObject, x, y, url)
	spaceObject.image = love.graphics.newImage(url)
	spaceObject.angle = 0; --0 in löve means to the right!
	spaceObject.acceleration = 15
	spaceObject.alpha = 1 -- angular acceleration
	
	spaceObject.density = 10;
	--mass
	--inertia = Trägheit

	--physics setup
	spaceObject.body = love.physics.newBody(world, x, y, "dynamic")
	spaceObject.body:setLinearDamping(0.5)
	spaceObject.body:setAngularDamping(3.0)
	spaceObject.shape = love.physics.newRectangleShape(spaceObject.image:getWidth(), spaceObject.image:getHeight())
	spaceObject.fixture = love.physics.newFixture(spaceObject.body, spaceObject.shape, spaceObject.density) -- A higher density gives it more mass.	
	spaceObject.fixture:setRestitution(1.0)
	
	--print(spaceObject.physics.body:getX()) --don't access directly with .x because NIL will be returned!!!
	--print(spaceObject.x)
	--print(spaceObject.physics.body:getY()) --don't access directly with .x because NIL will be returned!!!
	--print(spaceObject.y)
end)

function SpaceObject:draw()
	local x, y = self.body:getPosition()
	local a = self.body:getAngle()
	--drawing
	love.graphics.draw(self.image, x, y, a, 1, 1, self.image:getWidth() / 2, self.image:getHeight() / 2)
	
	--print(self.physics.body:getX(), self.physics.body:getY())
	--love.graphics.setColor(193, 47, 14) --set the drawing color to red for the ball
	--love.graphics.circle("fill", self.physics.body:getX(), self.physics.body:getY(), 20)
	
end


