require 'SpaceObject'

function love.load()
	love.graphics.setBackgroundColor(0,0,0)
	
	m = 10
	love.physics.setMeter(m) --the height of a meter our worlds will be 64px
	world = love.physics.newWorld(0, 0, true) --create a world for the bodies to exist in with horizontal gravity of 0 and vertical gravity of 0 and are allowed to sleep
	
	
	--create non-pc ships
	
	
	--create spaceports
	spaceStations = {}
	for i=1,10 do
		table.insert(spaceStations, SpaceObject(math.random(100, 924), math.random(50, 718),  "assets/images/ufo.png"))--TODO: use simple-physics objects for space stations later on
	end
	
	--create player
	playerShip = SpaceObject(love.graphics.getWidth()/2, love.graphics.getHeight()/2,  "assets/images/red_ship.png")
end



function love.update(dt)
	if gameIsPaused then return end
	
	world:update(dt) --update physics

	-- apply force in newtons, mass * acceleration, never use dt in here
	local force = playerShip.acceleration * m * playerShip.body:getMass()
	
	if love.keyboard.isDown("up") then
		playerShip.body:applyForce(playerShip.body:getWorldVector(force, 0)) 
	elseif love.keyboard.isDown("down") then
		playerShip.body:applyForce(playerShip.body:getWorldVector(-force, 0)) 
	end	
	
	-- apply torque in newton meters (inertia * acceleration), never use dt
	local torque = playerShip.alpha * m * playerShip.body:getInertia()
	
	if love.keyboard.isDown("left") then
		playerShip.body:applyTorque(-torque)
	elseif love.keyboard.isDown("right") then
		playerShip.body:applyTorque(torque)
	end
end

function love.draw()

	for i=1,# spaceStations do
		spaceStations[i]:draw()
	end

	 playerShip:draw() --draw player last = above everything else
	 drawUI()
end

function drawUI()
	 love.graphics.print("Current FPS: "..tostring(love.timer.getFPS( )), 10, 10)
	 love.graphics.print("current collisions:"..tostring(world:getContactCount()), 10, 25)
end

function love.focus(f) 
	gameIsPaused = not f 
end



